#ifndef __COLORDEF_HPP
#define __COLORDEF_HPP

#define COLOR_WHITE                         (SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00))
#define COLOR_BLACK                         (SFXRGBColor(0x00, 0x00, 0x00, 0x00))
#define COLOR_DENIM                         (SFXRGBColor(0x15, 0x60, 0xBD, 0x00))
#define COLOR_PURPLE_HEART                  (SFXRGBColor(0x65, 0x2D, 0xC1, 0x00))
#define COLOR_DODGER_BLUE                   (SFXRGBColor(0x1E, 0x90, 0xFF, 0x00))
#define COLOR_MINT_GREEN                    (SFXRGBColor(0x98, 0xFF, 0x98, 0x00))
#define COLOR_PERIWINKLE                    (SFXRGBColor(0xCC, 0xCC, 0xFF, 0x00))
#define COLOR_REEF                          (SFXRGBColor(0xC9, 0xFF, 0xA2, 0x00))
#define COLOR_SUPERNOVA                     (SFXRGBColor(0xFF, 0xCC, 0x00, 0x00))
#define COLOR_CINNABAR                      (SFXRGBColor(0xE3, 0x42, 0x34, 0x00))
#define COLOR_ELE_SKYBLUE                   (SFXRGBColor(0xEE, 0xEE, 0xFF, 0x00))
#define COLOR_ELE_SKYGREEN                  (SFXRGBColor(0xEE, 0xFF, 0xEE, 0x00))

#define COLOR_MENU_SEL_BACK                 COLOR_PURPLE_HEART
#define COLOR_MENU_SEL_FORE                 COLOR_WHITE
#define COLOR_MENU_TITLE_FORE               COLOR_WHITE
#define COLOR_MENU_TITLE_BACK               COLOR_DENIM
#define COLOR_MENU_ITEM_EVEN_BACK           COLOR_ELE_SKYBLUE
#define COLOR_MENU_ITEM_ODD_BACK            COLOR_ELE_SKYGREEN

#endif//__COLORDEF_HPP
