#include "SchedulerConfig.hpp"

SFCError SchedulerConfig::Load(Void)
{
    return _config.Load(SFXPath("/calendar/config.dat"));
}

SFCError SchedulerConfig::Save(Void)
{
    return _config.Save();
}

Bool SchedulerConfig::ReadLongDate(Void)
{
    return _config.ReadBool(OPTION_LONGDATE, false);
}

SFCError SchedulerConfig::WriteLongDate(Bool param)
{
    return _config.WriteBool(OPTION_LONGDATE, param);
}

Bool SchedulerConfig::ReadMdy(Void)
{
    return _config.ReadBool(OPTION_MDY, false);
}

SFCError SchedulerConfig::WriteMdy(Bool param)
{
    return _config.WriteBool(OPTION_MDY, param);
}


