#ifndef __SCHEDULERCONFIG_HPP
#define __SCHEDULERCONFIG_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(SchedulerConfig)
class SchedulerConfig
{
private:
    SFXConfig                       _config;            // IvV
    enum {
        OPTION_LONGDATE = 1,
        OPTION_MDY
    };
public:
            SFCError                Load(Void);
            SFCError                Save(Void);
            Bool                    ReadLongDate(Void);
            SFCError                WriteLongDate(Bool param);
            Bool                    ReadMdy(Void);
            SFCError                WriteMdy(Bool param);
};

#endif // __SCHEDULERCONFIG_HPP //
