#include "syncscheduler_sfy.hpp"
#include "MainWindow.hpp"

// u[g[_[
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    // @ŗpꍇAŃCZX R[hݒ肵܂B
    *license = "heap://"
        "R3V3Z7XPWQT2XBZ8S4YORMFV5SIUMXBU0Y2U1XHXBU45WKV6JRBW3WEU4WCRMVFUKTBV0UMWF"
        "EVMYPRPVBY8X7SPWOKX9SCVI4Y1RGTGU80SPREYBRAXPRLRMZ1AX1X0R0V5YLY8W7WKY0SARF"
        "SJ5T3Z8VCZ4U8YPX7UK2T2YBSLX0VQSKDV3V9U5SPU5XHY6TLV6T7T1Y3X9LXDXMSPUFXBT0Z"
        "CW7T02U1RLSD0S3W2UJYJWHVJVK9U7VHRHU3RPTP3WLWJY2NVMT9TESNX3TIWOU9UMSQVNU6S"
        "5W1V9W7TLT1Z0VCRHRMLU3S6Y8BVO96XDTBW5RAX2SDWER6V8UEU8Y9W5X2UGSDW8VPS5SN/";

    return (id == AEECLSID_SYNCSCHEDULER_SFY) ? (&syncscheduler_sfy::Factory) : (null);
}

// t@Ng֐
SFCInvokerPtr syncscheduler_sfy::Factory(Void)
{
    return ::new syncscheduler_sfy;
}

// RXgN^
syncscheduler_sfy::syncscheduler_sfy(Void) static_throws
{
    if (static_try()) {
        // L[nh̓o^
        static_throw(RegisterHandler(
            SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
            XANDLER_INTERNAL(OnKey)
        ));
        if (static_try()) {
            // ݒ̓ǂݍ
            static_throw(_config.Load());
            if (static_try()) {
                // J_[\̓ǂݍ
                _vcalCollection.Load();
                if (static_try()) {
                    // \tgL[Rg[̍쐬Ɣzu
                    static_throw(CreateSoft());
                    if (static_try()) {
                        // \tgL[̈̊m
                        _content = GetLocalBound().SetBottom(_softkey->GetRealBound().GetTop());
                        // t[̍쐬Ɣzu
                        static_throw(CreateFrame());
                        if (static_try()) {
                            // CEBhE̍쐬Ɣzu
                            static_throw(CreateMain());
                        }
                    }
                }
            }
        }
    }
}

// fXgN^
syncscheduler_sfy::~syncscheduler_sfy(Void)
{
}

// ݒ擾
SchedulerConfigPtr syncscheduler_sfy::GetConfig(Void)
{
    return &(static_cast<syncscheduler_sfyPtr>(GetInstance())->_config);
}

// \̃CX^X擾
VCalendarCollectionPtr syncscheduler_sfy::GetVCalCollection(Void)
{
    return &static_cast<syncscheduler_sfyPtr>(GetInstance())->_vcalCollection;
}

// \tgL[Rg[擾
SFZSoftKeyControlSmp syncscheduler_sfy::GetSoftKey(Void)
{
    return static_cast<syncscheduler_sfyPtr>(GetInstance())->_softkey;
}

// \tgL[Rg[̈擾
SFXRectangleConstRef syncscheduler_sfy::GetContentRect(Void)
{
    return static_cast<syncscheduler_sfyPtr>(GetInstance())->_content;
}

// _CAOwp[̎擾
DialogerPtr syncscheduler_sfy::GetDialoger(Void)
{
    return &static_cast<syncscheduler_sfyPtr>(GetInstance())->_dialoger;
}

// \[X̓ǂݍ
SFXWideString syncscheduler_sfy::LoadString(SIntN id)
{
    SFBShellSmp shell = SFBShell::GetInstance();
    return shell->LoadResString(SYNCSCHEDULER_SFY_RES_FILE, id);
}

// \tgL[Rg[̍쐬Ɣzu
SFCError syncscheduler_sfy::CreateSoft(Void)
{
    SFCError error;

    if ((_softkey = SFZSoftKeyControl::NewInstance(&error)) != null) {
        if ((error = _softkey->SetParent(GetThis())) == SFERR_NO_ERROR) {
            // \tgL[x̑S\[Xt@Co^
            error = _softkey->RegisterTextRange(
                IDS_SOFTKEY_EXIT, SFXPath(SYNCSCHEDULER_SFY_RES_FILE),
                IDS_SOFTKEY_EXIT, IDS_SOFTKEY_EDIT
            );
            if (error == SFERR_NO_ERROR) {
                _softkey->SetRealBound(_softkey->GetSuitableBound());
                _softkey->SetState(true, true, false, false);
            }
        }
    }
    return error;
}

// t[̍쐬Ɣzu
SFCError syncscheduler_sfy::CreateFrame(Void)
{
    SFCError error;

    if ((_frame = SFZTitlePlainFrame::NewInstance(&error)) != null) {
        if ((error = _frame->SetParent(GetThis())) == SFERR_NO_ERROR) {
            // ^Cg̐ݒ
            if ((error = _frame->SetText(LoadString(IDS_APPNAME))) == SFERR_NO_ERROR) {
                _frame->SetRealBound(GetContentRect());
                _frame->SetState(true, true, true, true);
                _frame->ToFront();
            }
        }
    }
    return error;
}

// CEBhE̍쐬Ɣzu
SFCError syncscheduler_sfy::CreateMain(Void)
{
    SFCError error;

    if ((_main = MainWindow::NewInstance(&error)) != null) {
        if ((error = _main->SetParent(_frame)) == SFERR_NO_ERROR) {
            _main->SetRealBound(_frame->GetLocalBound().Deflate(_frame->GetSuitableMargin()));
            _main->SetState(true, true, true, true);
            // qX|_̍쐬
            error = _main->Make();
        }
    }
    return error;
}

// L[nh
XANDLER_IMPLEMENT_BOOLEVENT(syncscheduler_sfy, OnKey, invoker, event)
{
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_CLR:
            result = true;
            break;
    }
    return result;
}
